/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laboratorul 2 Exercitiul 1
 * Digital I/O
 *********************************************************************************/
#define F_CPU 16000000
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>

#include "lcd.h"

#define keypad1_PORT PORTA //Keypad1 Port
#define keypad1_DDR DDRA //Data Direction Register
#define keypad1_PIN PINA //Keypad1 Port Pins

#define keypad2_PORT PORTD //Keypad2 Port
#define keypad2_DDR DDRD //Data Direction Register
#define keypad2_PIN PIND //Keypad2 Port Pins

#define col1_1 PA2 //Coloana 1 PA2
#define col1_2 PA0 //Coloana 2 PA0
#define col1_3 PA4 //Coloana 3 PA4

#define col2_1 PD4 //Coloana 1 PD4
#define col2_2 PD6 //Coloana 2 PD6
#define col2_3 PD2 //Coloana 3 PD2

#define TRUE 1
#define FALSE 0

unsigned char keyval; //Tasta Apasata
int key_pressed;
//unsigned char LineAdress[2] = {0x00, 0x40};		// Adresa celor doua linii ale LCD-ului

void key_init (){
	keypad1_DDR = 0xF0;
	keypad1_PORT = 0x0F;

	keypad2_DDR = 0xF0;
	keypad2_PORT = 0x0F;

}

unsigned char get_key(){

	unsigned key_val = '0';

	_delay_ms(10);
	
	//Prima Tastura
	//Prima coloana
	key_init();
	keypad1_PORT = 0b01111011;

	if (!bit_is_set(keypad1_PIN,1)){  //Linia 1
		while (!bit_is_set(keypad1_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '1';
	}

	if (!bit_is_set(keypad1_PIN,6)){  //Linia 2
		while (!bit_is_set(keypad1_PIN,6)) ;
		key_pressed = TRUE;
		key_val = '4';
	}

	if (!bit_is_set(keypad1_PIN,5)){   // Linia 3
		while (!bit_is_set(keypad1_PIN,5)) ;
		key_pressed = TRUE;
		key_val = '7';
	}

	if (!bit_is_set(keypad1_PIN,3)){   //Linia 4
		while (!bit_is_set(keypad1_PIN,3)) ;
		key_pressed = TRUE;
		key_val = '.';
	}

	//A doua coloana
	key_init();
	keypad1_PORT = 0b011110;

	if (!bit_is_set(keypad1_PIN,1)){
		while (!bit_is_set(keypad1_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '2';
	}

	if (!bit_is_set(keypad1_PIN,6)){
		while (!bit_is_set(keypad1_PIN,6)) ;
		key_pressed = TRUE;
		key_val = '5';
	}

	if (!bit_is_set(keypad1_PIN,5)){
		while (!bit_is_set(keypad1_PIN,5)) ;
		key_pressed = TRUE;
		key_val = '8';
	}

	if (!bit_is_set(keypad1_PIN,3)){
		while (!bit_is_set(keypad1_PIN,3)) ;
		key_pressed = TRUE;
		key_val = '0';
	}

	//A treia coloana
	key_init();
	keypad1_PORT = 0b01101111;

	if (!bit_is_set(keypad1_PIN,1)){
		while (!bit_is_set(keypad1_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '3';
	}

	if (!bit_is_set(keypad1_PIN,6)){
		while (!bit_is_set(keypad1_PIN,6)) ;
		key_pressed = TRUE;
		key_val = '6';
	}

	if (!bit_is_set(keypad1_PIN,5)){
		while (!bit_is_set(keypad1_PIN,5)) ;
		key_pressed = TRUE;
		key_val = '9';
	}

	if (!bit_is_set(keypad1_PIN,3)){
		while (!bit_is_set(keypad1_PIN,3)) ;
		key_pressed = TRUE;
		key_val = 'i';
	}

	
	//A doua Tastura
	//Prima coloana
	key_init();
	keypad2_PORT = 0b01111011;

	if (!bit_is_set(keypad2_PIN,1)){  //Linia 1
		while (!bit_is_set(keypad2_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '+';
	}

	if (!bit_is_set(keypad2_PIN,6)){  //Linia 2
		while (!bit_is_set(keypad2_PIN,6)) ;
		key_pressed = TRUE;
		key_val = '/';
	}

	if (!bit_is_set(keypad2_PIN,5)){   // Linia 3
		while (!bit_is_set(keypad2_PIN,5)) ;
		key_pressed = TRUE;
		key_val = 'b';
	}

	if (!bit_is_set(keypad2_PIN,3)){   //Linia 4
		while (!bit_is_set(keypad2_PIN,3)) ;
		key_pressed = TRUE;
		key_val = '=';
	}

	//A doua coloana
	key_init();
	keypad2_PORT = 0b011110;

	if (!bit_is_set(keypad2_PIN,1)){
		while (!bit_is_set(keypad2_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '-';
	}

	if (!bit_is_set(keypad2_PIN,6)){
		while (!bit_is_set(keypad2_PIN,6)) ;
		key_pressed = TRUE;
		key_val = 'l';
	}

	if (!bit_is_set(keypad2_PIN,5)){
		while (!bit_is_set(keypad2_PIN,5)) ;
		key_pressed = TRUE;
		key_val = 'x';
	}

	if (!bit_is_set(keypad2_PIN,3)){
		while (!bit_is_set(keypad2_PIN,3)) ;
		key_pressed = TRUE;
		key_val = 'c';
	}

	//A treia coloana
	key_init();
	keypad2_PORT = 0b01101111;

	if (!bit_is_set(keypad2_PIN,1)){
		while (!bit_is_set(keypad2_PIN,1)) ;
		key_pressed = TRUE;
		key_val = '*';
	}

	if (!bit_is_set(keypad2_PIN,6)){
		while (!bit_is_set(keypad2_PIN,6)) ;
		key_pressed = TRUE;
		key_val = '^';
	}

	if (!bit_is_set(keypad2_PIN,5)){
		while (!bit_is_set(keypad2_PIN,5)) ;
		key_pressed = TRUE;
		key_val = 'd';
	}

	if (!bit_is_set(keypad2_PIN,3)){
		while (!bit_is_set(keypad2_PIN,3)) ;
		key_pressed = TRUE;
		key_val = '%';
	}

	key_init();

	return key_val;
}

int my_pow (int n, int p){
	int i;
	for (i=0;i<n;i++)
		n*=n;
	return n;
}

char my_itoc(n){
	char c;
	switch (n){
		case 0:
			c = '0';
			break;
		case 1:
			c = '1';
			break;
		case 2:
			c = '2';
			break;
		case 3:
			c = '3';
			break;
		case 4:
			c = '4';
			break;
		case 5:
			c = '5';
			break;
		case 6:
			c = '6';
			break;
		case 7:
			c = '7';
			break;
		case 8:
			c = '8';
			break;
		case 9:
			c = '9';
			break;
	}
	return c;
}

void my_reverse(char s[]){
	int i, j;
	char c;
 
	for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
        c = s[i];
        s[i] = s[j];
        s[j] = c;
     }
 }


void my_itoa(int n,char str[],int dim){
	int rest;
	char c;
	dim = 0;
	while (n>0){
		rest = n%10;
		c = my_itoc(rest);
		n = n/10;
		str[dim] = c;
		dim ++;
	}
	my_reverse(str);
}

int main()
{
	char nr1[20] ="";
	char nr2[20] ="";
	char clear[20]="";
	int dim = 0;
	unsigned char last_op ='c';
	int result = 0;
	int i;

	LCD_init();
	
	key_pressed = FALSE;
	keyval = 0;
	key_init();

	LCD_writeInstruction(LCD_INSTR_gotoCGRAM);
	LCD_writeInstruction(LCD_INSTR_clearDisplay);
	LCD_gotoXY(0, 0);
	LCD_print("COMPUTE");
	LCD_gotoXY(0,1);

	while (1){
		keyval = get_key();

		if (key_pressed == TRUE){
			if (keyval == 'c'){
				LCD_gotoXY(0,0);
			
				for (i=0;i<15;i++)
					LCD_writeData(' ');
				LCD_gotoXY(0,1);
				for (i=0;i<15;i++)
					LCD_writeData(' ');
			
				last_op = 'c';
		
			}
			else if ((keyval == '+') || (keyval == '-') || (keyval == '*') || (keyval == '/') || (keyval == '^')){
				if ((last_op == 'c' )|| (last_op == '=')){
				
					strcmp(nr2,nr1);
					LCD_gotoXY(0,0);
					for (i=0;i<15;i++)
						LCD_writeData(' ');
					LCD_writeData(keyval);
					last_op = keyval; 
				}
			else if (keyval == '='){
				switch (last_op){
					case '+':
						result = atoi(nr1) + atoi(nr2);
						break;
					case '-':
						result = atoi(nr2) - atoi(nr1);
						break;
					case '*':
						result = atoi(nr1) * atoi(nr2);
						break;
					case '/':
						result = atoi(nr2) / atoi(nr1);
						break;
					case '^':
						result = my_pow(atoi(nr2),atoi(nr1));
						break;
					}
				
				for (i=0;i<20;i++){
					nr1[i] = '\0';
				}
				itoa(result,nr1,&dim);
				LCD_gotoXY(0,0);
				for (i=0;i<15;i++)
						LCD_writeData(' ');
				for (i=0;i<dim;i++)
					LCD_writeData(nr1[i]);
				last_op = keyval;
				}
			}
			
			else if (keyval == 'x'){
				LCD_gotoXY(0,0);
				for (i=0;i<15;i++)
						LCD_writeData(' ');
				LCD_printHexa(atoi(nr1));
				last_op = 'c';
			}
			else if (keyval == 'd'){
				LCD_gotoXY(0,0);
				for (i=0;i<15;i++)
						LCD_writeData(' ');
				LCD_printDecimal2u(atoi(nr1));
				last_op = 'c';
			}
			else{
				LCD_writeData(keyval);
				nr1[dim] = keyval;
				dim++;
				last_op = 'c';
			}
		}
		key_pressed = FALSE;
	}
	
	return 0;
}
